/* This code was adapted from http://www.createwindow.com/programming/crc32/index.htm
 * It is believed to be free (Public Domain)
 */
#ifndef CRC32_H_
#define CRC32_H_

#include <stdint.h>

class CRC32 {
public:
	CRC32();
    uint32_t Compute(void *data, int len, uint32_t CRC=0xFFFFFFFF);	/* Creates a CRC from a text string */
    uint32_t Finalize(uint32_t CRC);	/* Gives the final result */

private:
	uint32_t LookupTable[256];					/* Lookup table array */ 
    void InitCRCTable();						/* Builds lookup table array */
    uint32_t Reflect(uint32_t ref, char ch);	/* Reflects CRC bits in the lookup table */
};

#endif /*CRC32_H_*/
