#ifndef CHARTCHOOSERDRAWINGAREA_H_
#define CHARTCHOOSERDRAWINGAREA_H_

#include <vector>
#include <string>
#include <libglademm.h>
#include <gtkmm/drawingarea.h>
#include <gdkmm/pixbuf.h>
#include <proj_api.h>
#include "DataStore.h"
#include "GeoChart.h"
#include "Route.h"

class ChartChooserDrawingArea : public Gtk::DrawingArea
{
public:
	enum Area_enum {
		AREA_CONTIGUOUS,
		AREA_ALASKA,
		AREA_HAWAII
	};

	ChartChooserDrawingArea(BaseObjectType* cobject,const Glib::RefPtr<Gnome::Glade::Xml>& glade_xml);
	virtual ~ChartChooserDrawingArea();

	void Init(
		std::string BackgroundImgPath,
		DataStore *Data,
		enum Area_enum Area,
		std::vector<GeoChart*>::iterator *SelectedCharti,
		Route *RouteData
		);
	void DrawGeoChartBounds(Cairo::RefPtr<Cairo::Context> Context,GeoChart *Chart);
	void LonLatToPixel(double Lon, double Lat, double *X, double *Y);
	void SetScaleOfs(double Lon1, double Lat1, double X1, double Y1,
					double Lon2, double Lat2, double X2, double Y2);
	void SetChartType(GeoChart::Type_enum ChartType);
	void Redraw();
	void DrawGreatCircleRoute(Route *RouteData);
	std::vector<GeoChart*>::iterator GetChartByLoc(double X, double Y);

private:
	bool on_expose_event(GdkEventExpose* ev);
	bool on_button_release_event(GdkEventButton * event);
	bool on_motion_notify_event(GdkEventMotion* event);

	std::string BackgroundImgPath;
	Glib::RefPtr<Gdk::Pixbuf> BgImgPixbuf;
	DataStore *Data;
	projPJ Proj;
	double XScale,XOfs,YScale,YOfs;
	enum GeoChart::Type_enum ChartType;
	std::vector<GeoChart*>::iterator *SelectedCharti, HoveredCharti; 
	Route *RouteData;
};

#endif /*CHARTCHOOSERDRAWINGAREA_H_*/
