#include <gtkmm/messagedialog.h>
#include <gtkmm/main.h>
#include "DisclaimerDialog.h"

DisclaimerDialog::DisclaimerDialog(std::string *GladeFilename)
{
	try
	{
		refXml = Gnome::Glade::Xml::create(*GladeFilename, "DisclaimerDialog");
	}
	catch (const Gnome::Glade::XmlError& ex)
	{
		Gtk::MessageDialog *message = new Gtk::MessageDialog("Error reading data file.  Program cannot continue.",
			false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CANCEL,true);
		message->run();
		InitFailure=true;
		GtkDialog=false;
		return;
	}

	refXml->get_widget("DisclaimerDialog",GtkDialog);
	refXml->get_widget("CancelButton",CancelButton);
	refXml->get_widget("AgreeButton",AgreeButton);

	CancelButton->signal_clicked().connect(sigc::mem_fun(this,&DisclaimerDialog::on_Cancel_clicked));
	AgreeButton->signal_clicked().connect(sigc::mem_fun(this,&DisclaimerDialog::on_Agree_clicked));

	GtkDialog->hide();
	GtkDialog->set_deletable(false);
	GtkDialog->show();
	InitFailure=false;
}

DisclaimerDialog::~DisclaimerDialog() {
	delete GtkDialog;
}

int DisclaimerDialog::Run() {
	return GtkDialog->run();
}

void DisclaimerDialog::on_Cancel_clicked() {
	GtkDialog->response(false);
}

void DisclaimerDialog::on_Agree_clicked() {
	GtkDialog->response(true);
}

bool DisclaimerDialog::GetInitFailure() {
	return InitFailure;
}
