#ifndef GPS_H_
#define GPS_H_

#include <time.h>
#include <gps.h>

#include "Config.h"

class GPS
{
public:
	GPS(Config *Cfg);
	virtual ~GPS();

	bool Activate();
	void Deactivate();
	bool GetActive();
	bool GetFix(double *Lon=NULL, double *Lat=NULL, double *Alt=NULL, double *Trk=NULL, double *Spd=NULL);

private:
	gps_data_t *gpsddata;
	pthread_t handler;
	bool ActiveFlag;
	bool gpsdActiveFlag;

	bool CheckMutex();
	Config *Cfg;
};

void GPS_Callback(gps_data_t *sentence, char *buf, size_t size, int i);

#endif /*GPS_H_*/
