#ifndef NFD_H_
#define NFD_H_

#include <string>
#include <vector>
#include <fstream>
#include <iostream>
#include <time.h>
#include "Config.h"
#include "Airport.h"
#include "NavAid.h"
#include "EnrouteWaypoint.h"

class NFD
{
public:
	NFD();
	~NFD();

	bool ParseHeader(std::ifstream *IFStream);
	void StoreLine(std::string Line);
	void FreeLines();
	bool ParseAirportLine(std::vector<std::string>::iterator AirportLinei, std::vector<Airport*> *Airports);
	bool ParseRunwayLine(std::vector<std::string>::iterator RunwayLinei, std::vector<Airport*> *Airports);
	bool ParseVORLine(std::vector<std::string>::iterator VORLinei, std::vector<NavAid*> *NavAids);
	bool ParseNDBLine(std::vector<std::string>::iterator NDBLinei, std::vector<NavAid*> *NavAids);
	bool ParseEnrouteWaypointLine(std::vector<std::string>::iterator EnrouteWaypointLinei, std::vector<EnrouteWaypoint*> *EnrouteWaypoints);
	std::vector<std::string> *GetAirportLines();
	std::vector<std::string> *GetRunwayLines();
	std::vector<std::string> *GetVORLines();
	std::vector<std::string> *GetNDBLines();
	std::vector<std::string> *GetEnrouteWaypointLines();
	std::string GetVolume();

private:
	std::vector<std::string> AirportLines;
	std::vector<std::string> RunwayLines;
	std::vector<std::string> VORLines;
	std::vector<std::string> NDBLines;
	std::vector<std::string> EnrouteWaypointLines;
	std::string Volume;
	int CRC;	/* Currently unchecked */
};

#endif /*NFD_H_*/
