#include <gtkmm/messagedialog.h>
#include <gtkmm/main.h>
#include "OverwriteFileDialog.h"
#include "Util.h"

OverwriteFileDialog::OverwriteFileDialog(std::string *GladeFilename)
{
	try
	{
		refXml = Gnome::Glade::Xml::create(*GladeFilename, "OverwriteFileDialog");
	}
	catch (const Gnome::Glade::XmlError& ex)
	{
		Gtk::MessageDialog *message = new Gtk::MessageDialog("Error reading data file.  Program cannot continue.",
			false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CANCEL,true);
		message->run();
		Gtk::Main::quit();
	}

	refXml->get_widget("OverwriteFileDialog",GtkDialog);
	refXml->get_widget("PathLabel",PathLabel);

	GtkDialog->set_deletable(false);
	Reset();
}

OverwriteFileDialog::~OverwriteFileDialog()
{
	delete GtkDialog;
}

enum OverwriteFileDialog::Response_enum OverwriteFileDialog::Run(std::string Path) {
	enum Response_Internal_enum InternalResponse;
	enum Response_enum Response=RESPONSE_CANCEL;

	if (Do==DO_KEEPALL)
		return RESPONSE_KEEP;
	if (Do==DO_OVERWRITEALL)
		return RESPONSE_OVERWRITE;

	PathLabel->set_text(Path.c_str());
	GtkDialog->show_all();
	InternalResponse=(enum Response_Internal_enum)GtkDialog->run();

	switch (InternalResponse) {
		case RESPONSE_INTERNAL_CANCEL:
			Response=RESPONSE_CANCEL;
			break;
		case RESPONSE_INTERNAL_KEEP:
			Response=RESPONSE_KEEP;
			break;
		case RESPONSE_INTERNAL_OVERWRITE:
			Response=RESPONSE_OVERWRITE;
			break;
		case RESPONSE_INTERNAL_KEEPALL:
			Do=DO_KEEPALL;
			Response=RESPONSE_KEEP;
			break;
		case RESPONSE_INTERNAL_OVERWRITEALL:
			Do=DO_OVERWRITEALL;
			Response=RESPONSE_OVERWRITE;
			break;
	}

	GtkDialog->hide();
	Util::ScheduleMainLoop();	/* Hide the dialog before continuing */

	return Response;
}

void OverwriteFileDialog::Reset() {
	Do=DO_ASK;
}
