#ifndef UTIL_H_
#define UTIL_H_

#include <string>
#include <vector>
#include "OverwriteFileDialog.h"

#define DEG2RAD(d) ((d)*(M_PI/180.0))
#define RAD2DEG(r) ((r)/(M_PI/180.0))

#define METERS2NM(m) ((m)*(1.0/1852))
#define NM2METERS(nm) ((nm)*1852)

#define METERS2FT(m) ((m)*3.2808399)
#define FT2METERS(ft) ((ft)/3.2808399)

#define MPERS2KT(mpers) ((mpers)*1.9438445)
#define KT2MPERS(kt) ((kt)/1.9438445)

#define KT2KPH(kt) ((kt)*1.85200)
#define KPH2KT(kph) ((kph)/1.85200)

#define MPH2KPH(mph) ((mph)*1.609344)
#define KPH2MPH(kph) ((kph)/1.609344)

#define FTPERMIN2KPH(ftm) ((ftm)/54.6806649)
#define KPH2FTPERMIN(kmh) ((kph)*54.6806649)

#define FTPERMIN2MPERS(fperm) ((fperm)*0.00508)
#define MPERS2FTPERMIN(mpers) ((mpers)/0.00508)

#define LB2KG(lb) ((lb)/2.20462262)
#define KG2LB(kg) ((kg)*2.20462262)

#define MILES2KM(mi) ((mi)*1.609344)
#define KM2MILES(km) ((km)/1.609344)

#define GAL2L(gal) ((gal)*3.78541178)
#define L2GAL(l) ((l)/3.78541178)

#define QT2L(qt) ((qt)*0.946352946)
#define L2QT(l) ((l)/0.946352946)

#define LAVGAS2KG(l) ((l)*0.721355092)
#define KG2LAVGAS(kg) ((kg)/0.721355092)

#define LMOGAS2KG(l) ((l)*0.727705893)
#define KG2LMOGAS(kg) ((kg)/0.727705893)

#define LJET2KG(l) ((l)*0.8075)
#define KG2LJET(kg) ((kg)/0.8075)

#define LOIL2KG(l) ((l)*0.874732919)
#define KG2LOIL(kg) ((kg)/0.874732919)

class Util
{
public:
	static void ShellExpand(std::string *str);
	static void ChkDir(std::string DirPath);
	static time_t GMMkTime(struct tm *tm);
	static bool CopyFile(std::string SrcPath, std::string DestDir, std::string DestName="", OverwriteFileDialog *OFD=NULL);
	static void ScheduleMainLoop();
	static std::string toUpper(std::string str);
	static std::string DoubleToStr(const double Number);
	static void Explode(const std::string Str, const std::string Delim, std::vector<std::string> *Tokens);
	static std::string GlobiPattern(std::string Pattern);
};

#endif /*UTIL_H_*/
