#include <gtkmm/messagedialog.h>
#include <gtkmm/main.h>
#include "WelcomeDialog.h"

WelcomeDialog::WelcomeDialog(std::string *GladeFilename, Config *Cfg)
{
	try
	{
		refXml = Gnome::Glade::Xml::create(*GladeFilename, "WelcomeDialog");
	}
	catch (const Gnome::Glade::XmlError& ex)
	{
		Gtk::MessageDialog *message = new Gtk::MessageDialog("Error reading data file.  Program cannot continue.",
			false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CANCEL,true);
		message->run();
		Gtk::Main::quit();
	}

	refXml->get_widget("WelcomeDialog",GtkDialog);

	refXml->get_widget("ShowButton",ShowButton);
	refXml->get_widget("LogoImage",LogoImage);

	/* Set the Logo image */
	try {
		LogoImage->set(std::string(DATADIR)+"/pixmaps/vifiricon.png");
	}
	catch (const Glib::FileError& ex) { /* Ignore errors */}

	this->Cfg=Cfg;
}

WelcomeDialog::~WelcomeDialog() {
	delete GtkDialog;
}

int WelcomeDialog::Run() {
	int Result;

	Result=GtkDialog->run();
	Cfg->SetShowWelcomeOnStartup(ShowButton->get_active());
	return Result;
}
