#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <list>
#include <cstdio>
#include <gtkmm/main.h>
#include <curl/curl.h>
#include "vifir.h"
#include "MainWindow.h"
#include "DisclaimerDialog.h"
#include "Config.h"
#include "Airport.h"
#include "NFD.h"
#include "Route.h"

int App::Run() {
	std::string GladeFilename;
	struct stat statbuf;
	Config Cfg;

	if (curl_global_init(CURL_GLOBAL_ALL)!=0) {
		fprintf(stderr,"Error initializing CURL library - aborting.\n");
		return 1;
	}

	if (!Cfg.Load()) {
		/* Ignore, use defaults */
	}

	/* Try a local file */
	GladeFilename="vifir.glade";
	if (stat(GladeFilename.c_str(),&statbuf)!=0) {
		/* Try a system file */
		GladeFilename=Cfg.GetPackageDataDir()+"/vifir.glade";
	}

	DisclaimerDialog *Disclaimer=new DisclaimerDialog(&GladeFilename);
	if (Disclaimer->GetInitFailure()==false && Disclaimer->Run()==true) {
		delete Disclaimer;
		MainWindow Window(this,&GladeFilename,&Cfg);
		Gtk::Main::run(*Window.GetGtkWindow());
	} else {
		delete Disclaimer;
	}

	curl_global_cleanup();

	return 0;
}

#include "Util.h"
#include <vector>
int main(int argc, char **argv) {
	Gtk::Main kit(&argc,&argv);
	App Application;
	return Application.Run();
}
